/* Utils.c generated by valac 0.48.19, the Vala compiler
 * generated from Utils.vala, do not modify */

/*-
 * Copyright (c) 2014-2018 elementary LLC.
 *
 * This software is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This software is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this software; if not, write to the
 * Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA 02110-1301, USA.
 *
 * Authored by: Corentin Noël <corentin@elementary.io>
 */

#include <gee.h>
#include <glib-object.h>
#include <glib.h>
#include <float.h>
#include <math.h>

#define DISPLAY_TYPE_MONITOR (display_monitor_get_type ())
#define DISPLAY_MONITOR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DISPLAY_TYPE_MONITOR, DisplayMonitor))
#define DISPLAY_MONITOR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), DISPLAY_TYPE_MONITOR, DisplayMonitorClass))
#define DISPLAY_IS_MONITOR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DISPLAY_TYPE_MONITOR))
#define DISPLAY_IS_MONITOR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), DISPLAY_TYPE_MONITOR))
#define DISPLAY_MONITOR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), DISPLAY_TYPE_MONITOR, DisplayMonitorClass))

typedef struct _DisplayMonitor DisplayMonitor;
typedef struct _DisplayMonitorClass DisplayMonitorClass;

#define DISPLAY_TYPE_MONITOR_MODE (display_monitor_mode_get_type ())
#define DISPLAY_MONITOR_MODE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DISPLAY_TYPE_MONITOR_MODE, DisplayMonitorMode))
#define DISPLAY_MONITOR_MODE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), DISPLAY_TYPE_MONITOR_MODE, DisplayMonitorModeClass))
#define DISPLAY_IS_MONITOR_MODE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DISPLAY_TYPE_MONITOR_MODE))
#define DISPLAY_IS_MONITOR_MODE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), DISPLAY_TYPE_MONITOR_MODE))
#define DISPLAY_MONITOR_MODE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), DISPLAY_TYPE_MONITOR_MODE, DisplayMonitorModeClass))

typedef struct _DisplayMonitorMode DisplayMonitorMode;
typedef struct _DisplayMonitorModeClass DisplayMonitorModeClass;
typedef struct _DisplayMonitorModePrivate DisplayMonitorModePrivate;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

struct _DisplayMonitorMode {
	GObject parent_instance;
	DisplayMonitorModePrivate * priv;
	gdouble* supported_scales;
	gint supported_scales_length1;
};

struct _DisplayMonitorModeClass {
	GObjectClass parent_class;
};

GType display_monitor_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (DisplayMonitor, g_object_unref)
GType display_monitor_mode_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (DisplayMonitorMode, g_object_unref)
GeeLinkedList* display_utils_get_common_monitor_modes (GeeLinkedList* monitors);
gdouble display_utils_get_min_compatible_scale (GeeLinkedList* monitors);
GeeLinkedList* display_monitor_get_modes (DisplayMonitor* self);
static gboolean _vala_double_array_contains (gdouble * stack,
                                      gint stack_length,
                                      const gdouble needle);
gint display_monitor_mode_get_width (DisplayMonitorMode* self);
gint display_monitor_mode_get_height (DisplayMonitorMode* self);
gdouble display_monitor_get_max_scale (DisplayMonitor* self);

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

static gboolean
_vala_double_array_contains (gdouble * stack,
                             gint stack_length,
                             const gdouble needle)
{
	gint i;
	for (i = 0; i < stack_length; i++) {
		if (needle == stack[i]) {
			return TRUE;
		}
	}
	return FALSE;
}

GeeLinkedList*
display_utils_get_common_monitor_modes (GeeLinkedList* monitors)
{
	GeeLinkedList* common_modes = NULL;
	GeeLinkedList* _tmp0_;
	gdouble min_scale = 0.0;
	gboolean first_monitor = FALSE;
	GeeLinkedList* result = NULL;
	g_return_val_if_fail (monitors != NULL, NULL);
	_tmp0_ = gee_linked_list_new (DISPLAY_TYPE_MONITOR_MODE, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
	common_modes = _tmp0_;
	min_scale = display_utils_get_min_compatible_scale (monitors);
	first_monitor = TRUE;
	{
		GeeLinkedList* _monitor_list = NULL;
		GeeLinkedList* _tmp1_;
		gint _monitor_size = 0;
		GeeLinkedList* _tmp2_;
		gint _tmp3_;
		gint _tmp4_;
		gint _monitor_index = 0;
		_tmp1_ = _g_object_ref0 (monitors);
		_monitor_list = _tmp1_;
		_tmp2_ = _monitor_list;
		_tmp3_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp2_);
		_tmp4_ = _tmp3_;
		_monitor_size = _tmp4_;
		_monitor_index = -1;
		while (TRUE) {
			gint _tmp5_;
			gint _tmp6_;
			DisplayMonitor* monitor = NULL;
			GeeLinkedList* _tmp7_;
			gpointer _tmp8_;
			_monitor_index = _monitor_index + 1;
			_tmp5_ = _monitor_index;
			_tmp6_ = _monitor_size;
			if (!(_tmp5_ < _tmp6_)) {
				break;
			}
			_tmp7_ = _monitor_list;
			_tmp8_ = gee_abstract_list_get ((GeeAbstractList*) _tmp7_, _monitor_index);
			monitor = (DisplayMonitor*) _tmp8_;
			if (first_monitor) {
				{
					GeeLinkedList* _mode_list = NULL;
					DisplayMonitor* _tmp9_;
					GeeLinkedList* _tmp10_;
					GeeLinkedList* _tmp11_;
					GeeLinkedList* _tmp12_;
					gint _mode_size = 0;
					GeeLinkedList* _tmp13_;
					gint _tmp14_;
					gint _tmp15_;
					gint _mode_index = 0;
					_tmp9_ = monitor;
					_tmp10_ = display_monitor_get_modes (_tmp9_);
					_tmp11_ = _tmp10_;
					_tmp12_ = _g_object_ref0 (_tmp11_);
					_mode_list = _tmp12_;
					_tmp13_ = _mode_list;
					_tmp14_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp13_);
					_tmp15_ = _tmp14_;
					_mode_size = _tmp15_;
					_mode_index = -1;
					while (TRUE) {
						gint _tmp16_;
						gint _tmp17_;
						DisplayMonitorMode* mode = NULL;
						GeeLinkedList* _tmp18_;
						gpointer _tmp19_;
						DisplayMonitorMode* _tmp20_;
						gdouble* _tmp21_;
						gint _tmp21__length1;
						_mode_index = _mode_index + 1;
						_tmp16_ = _mode_index;
						_tmp17_ = _mode_size;
						if (!(_tmp16_ < _tmp17_)) {
							break;
						}
						_tmp18_ = _mode_list;
						_tmp19_ = gee_abstract_list_get ((GeeAbstractList*) _tmp18_, _mode_index);
						mode = (DisplayMonitorMode*) _tmp19_;
						_tmp20_ = mode;
						_tmp21_ = _tmp20_->supported_scales;
						_tmp21__length1 = _tmp20_->supported_scales_length1;
						if (_vala_double_array_contains (_tmp21_, _tmp21__length1, min_scale)) {
							GeeLinkedList* _tmp22_;
							DisplayMonitorMode* _tmp23_;
							_tmp22_ = common_modes;
							_tmp23_ = mode;
							gee_abstract_collection_add ((GeeAbstractCollection*) _tmp22_, _tmp23_);
						}
						_g_object_unref0 (mode);
					}
					_g_object_unref0 (_mode_list);
				}
				first_monitor = FALSE;
			} else {
				GeeLinkedList* to_remove = NULL;
				GeeLinkedList* _tmp24_;
				GeeLinkedList* _tmp60_;
				GeeLinkedList* _tmp61_;
				_tmp24_ = gee_linked_list_new (DISPLAY_TYPE_MONITOR_MODE, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
				to_remove = _tmp24_;
				{
					GeeLinkedList* _mode_to_check_list = NULL;
					GeeLinkedList* _tmp25_;
					GeeLinkedList* _tmp26_;
					gint _mode_to_check_size = 0;
					GeeLinkedList* _tmp27_;
					gint _tmp28_;
					gint _tmp29_;
					gint _mode_to_check_index = 0;
					_tmp25_ = common_modes;
					_tmp26_ = _g_object_ref0 (_tmp25_);
					_mode_to_check_list = _tmp26_;
					_tmp27_ = _mode_to_check_list;
					_tmp28_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp27_);
					_tmp29_ = _tmp28_;
					_mode_to_check_size = _tmp29_;
					_mode_to_check_index = -1;
					while (TRUE) {
						gint _tmp30_;
						gint _tmp31_;
						DisplayMonitorMode* mode_to_check = NULL;
						GeeLinkedList* _tmp32_;
						gpointer _tmp33_;
						gboolean mode_found = FALSE;
						_mode_to_check_index = _mode_to_check_index + 1;
						_tmp30_ = _mode_to_check_index;
						_tmp31_ = _mode_to_check_size;
						if (!(_tmp30_ < _tmp31_)) {
							break;
						}
						_tmp32_ = _mode_to_check_list;
						_tmp33_ = gee_abstract_list_get ((GeeAbstractList*) _tmp32_, _mode_to_check_index);
						mode_to_check = (DisplayMonitorMode*) _tmp33_;
						mode_found = FALSE;
						{
							GeeLinkedList* _monitor_mode_list = NULL;
							DisplayMonitor* _tmp34_;
							GeeLinkedList* _tmp35_;
							GeeLinkedList* _tmp36_;
							GeeLinkedList* _tmp37_;
							gint _monitor_mode_size = 0;
							GeeLinkedList* _tmp38_;
							gint _tmp39_;
							gint _tmp40_;
							gint _monitor_mode_index = 0;
							_tmp34_ = monitor;
							_tmp35_ = display_monitor_get_modes (_tmp34_);
							_tmp36_ = _tmp35_;
							_tmp37_ = _g_object_ref0 (_tmp36_);
							_monitor_mode_list = _tmp37_;
							_tmp38_ = _monitor_mode_list;
							_tmp39_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp38_);
							_tmp40_ = _tmp39_;
							_monitor_mode_size = _tmp40_;
							_monitor_mode_index = -1;
							while (TRUE) {
								gint _tmp41_;
								gint _tmp42_;
								DisplayMonitorMode* monitor_mode = NULL;
								GeeLinkedList* _tmp43_;
								gpointer _tmp44_;
								gboolean _tmp45_ = FALSE;
								DisplayMonitorMode* _tmp46_;
								gint _tmp47_;
								gint _tmp48_;
								DisplayMonitorMode* _tmp49_;
								gint _tmp50_;
								gint _tmp51_;
								_monitor_mode_index = _monitor_mode_index + 1;
								_tmp41_ = _monitor_mode_index;
								_tmp42_ = _monitor_mode_size;
								if (!(_tmp41_ < _tmp42_)) {
									break;
								}
								_tmp43_ = _monitor_mode_list;
								_tmp44_ = gee_abstract_list_get ((GeeAbstractList*) _tmp43_, _monitor_mode_index);
								monitor_mode = (DisplayMonitorMode*) _tmp44_;
								_tmp46_ = mode_to_check;
								_tmp47_ = display_monitor_mode_get_width (_tmp46_);
								_tmp48_ = _tmp47_;
								_tmp49_ = monitor_mode;
								_tmp50_ = display_monitor_mode_get_width (_tmp49_);
								_tmp51_ = _tmp50_;
								if (_tmp48_ == _tmp51_) {
									DisplayMonitorMode* _tmp52_;
									gint _tmp53_;
									gint _tmp54_;
									DisplayMonitorMode* _tmp55_;
									gint _tmp56_;
									gint _tmp57_;
									_tmp52_ = mode_to_check;
									_tmp53_ = display_monitor_mode_get_height (_tmp52_);
									_tmp54_ = _tmp53_;
									_tmp55_ = monitor_mode;
									_tmp56_ = display_monitor_mode_get_height (_tmp55_);
									_tmp57_ = _tmp56_;
									_tmp45_ = _tmp54_ == _tmp57_;
								} else {
									_tmp45_ = FALSE;
								}
								if (_tmp45_) {
									mode_found = TRUE;
									_g_object_unref0 (monitor_mode);
									break;
								}
								_g_object_unref0 (monitor_mode);
							}
							_g_object_unref0 (_monitor_mode_list);
						}
						if (mode_found == FALSE) {
							GeeLinkedList* _tmp58_;
							DisplayMonitorMode* _tmp59_;
							_tmp58_ = to_remove;
							_tmp59_ = mode_to_check;
							gee_abstract_collection_add ((GeeAbstractCollection*) _tmp58_, _tmp59_);
						}
						_g_object_unref0 (mode_to_check);
					}
					_g_object_unref0 (_mode_to_check_list);
				}
				_tmp60_ = common_modes;
				_tmp61_ = to_remove;
				gee_collection_remove_all ((GeeCollection*) _tmp60_, (GeeCollection*) _tmp61_);
				_g_object_unref0 (to_remove);
			}
			_g_object_unref0 (monitor);
		}
		_g_object_unref0 (_monitor_list);
	}
	result = common_modes;
	return result;
}

gdouble
display_utils_get_min_compatible_scale (GeeLinkedList* monitors)
{
	gdouble min_scale = 0.0;
	gdouble result = 0.0;
	g_return_val_if_fail (monitors != NULL, 0.0);
	min_scale = DBL_MAX;
	{
		GeeLinkedList* _monitor_list = NULL;
		GeeLinkedList* _tmp0_;
		gint _monitor_size = 0;
		GeeLinkedList* _tmp1_;
		gint _tmp2_;
		gint _tmp3_;
		gint _monitor_index = 0;
		_tmp0_ = _g_object_ref0 (monitors);
		_monitor_list = _tmp0_;
		_tmp1_ = _monitor_list;
		_tmp2_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp1_);
		_tmp3_ = _tmp2_;
		_monitor_size = _tmp3_;
		_monitor_index = -1;
		while (TRUE) {
			gint _tmp4_;
			gint _tmp5_;
			DisplayMonitor* monitor = NULL;
			GeeLinkedList* _tmp6_;
			gpointer _tmp7_;
			DisplayMonitor* _tmp8_;
			_monitor_index = _monitor_index + 1;
			_tmp4_ = _monitor_index;
			_tmp5_ = _monitor_size;
			if (!(_tmp4_ < _tmp5_)) {
				break;
			}
			_tmp6_ = _monitor_list;
			_tmp7_ = gee_abstract_list_get ((GeeAbstractList*) _tmp6_, _monitor_index);
			monitor = (DisplayMonitor*) _tmp7_;
			_tmp8_ = monitor;
			min_scale = MIN (min_scale, display_monitor_get_max_scale (_tmp8_));
			_g_object_unref0 (monitor);
		}
		_g_object_unref0 (_monitor_list);
	}
	result = min_scale;
	return result;
}

