/* DisplayWindow.c generated by valac 0.48.19, the Vala compiler
 * generated from DisplayWindow.vala, do not modify */

/*-
 * Copyright 2014-2021 elementary, Inc.
 *
 * This software is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This software is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this software; if not, write to the
 * Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA 02110-1301, USA.
 *
 * Authored by: Corentin Noël <corentin@elementary.io>
 */

#include <handy.h>
#include <glib-object.h>
#include <glib.h>
#include <gtk/gtk.h>
#include <stdlib.h>
#include <string.h>
#include <gdk/gdk.h>

#define DISPLAY_TYPE_DISPLAY_WINDOW (display_display_window_get_type ())
#define DISPLAY_DISPLAY_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DISPLAY_TYPE_DISPLAY_WINDOW, DisplayDisplayWindow))
#define DISPLAY_DISPLAY_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), DISPLAY_TYPE_DISPLAY_WINDOW, DisplayDisplayWindowClass))
#define DISPLAY_IS_DISPLAY_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DISPLAY_TYPE_DISPLAY_WINDOW))
#define DISPLAY_IS_DISPLAY_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), DISPLAY_TYPE_DISPLAY_WINDOW))
#define DISPLAY_DISPLAY_WINDOW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), DISPLAY_TYPE_DISPLAY_WINDOW, DisplayDisplayWindowClass))

typedef struct _DisplayDisplayWindow DisplayDisplayWindow;
typedef struct _DisplayDisplayWindowClass DisplayDisplayWindowClass;
typedef struct _DisplayDisplayWindowPrivate DisplayDisplayWindowPrivate;

#define DISPLAY_TYPE_VIRTUAL_MONITOR (display_virtual_monitor_get_type ())
#define DISPLAY_VIRTUAL_MONITOR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DISPLAY_TYPE_VIRTUAL_MONITOR, DisplayVirtualMonitor))
#define DISPLAY_VIRTUAL_MONITOR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), DISPLAY_TYPE_VIRTUAL_MONITOR, DisplayVirtualMonitorClass))
#define DISPLAY_IS_VIRTUAL_MONITOR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DISPLAY_TYPE_VIRTUAL_MONITOR))
#define DISPLAY_IS_VIRTUAL_MONITOR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), DISPLAY_TYPE_VIRTUAL_MONITOR))
#define DISPLAY_VIRTUAL_MONITOR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), DISPLAY_TYPE_VIRTUAL_MONITOR, DisplayVirtualMonitorClass))

typedef struct _DisplayVirtualMonitor DisplayVirtualMonitor;
typedef struct _DisplayVirtualMonitorClass DisplayVirtualMonitorClass;
enum  {
	DISPLAY_DISPLAY_WINDOW_0_PROPERTY,
	DISPLAY_DISPLAY_WINDOW_VIRTUAL_MONITOR_PROPERTY,
	DISPLAY_DISPLAY_WINDOW_NUM_PROPERTIES
};
static GParamSpec* display_display_window_properties[DISPLAY_DISPLAY_WINDOW_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

struct _DisplayDisplayWindow {
	HdyWindow parent_instance;
	DisplayDisplayWindowPrivate * priv;
};

struct _DisplayDisplayWindowClass {
	HdyWindowClass parent_class;
};

struct _DisplayDisplayWindowPrivate {
	DisplayVirtualMonitor* _virtual_monitor;
};

static gint DisplayDisplayWindow_private_offset;
static gpointer display_display_window_parent_class = NULL;

GType display_display_window_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (DisplayDisplayWindow, g_object_unref)
GType display_virtual_monitor_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (DisplayVirtualMonitor, g_object_unref)
#define DISPLAY_DISPLAY_WINDOW_SPACING 12
DisplayDisplayWindow* display_display_window_new (DisplayVirtualMonitor* virtual_monitor);
DisplayDisplayWindow* display_display_window_construct (GType object_type,
                                                        DisplayVirtualMonitor* virtual_monitor);
DisplayVirtualMonitor* display_display_window_get_virtual_monitor (DisplayDisplayWindow* self);
static void display_display_window_set_virtual_monitor (DisplayDisplayWindow* self,
                                                 DisplayVirtualMonitor* value);
static GObject * display_display_window_constructor (GType type,
                                              guint n_construct_properties,
                                              GObjectConstructParam * construct_properties);
const gchar* display_virtual_monitor_get_display_name (DisplayVirtualMonitor* self);
gint display_virtual_monitor_get_current_x (DisplayVirtualMonitor* self);
gint display_virtual_monitor_get_current_y (DisplayVirtualMonitor* self);
static void display_display_window_finalize (GObject * obj);
static GType display_display_window_get_type_once (void);
static void _vala_display_display_window_get_property (GObject * object,
                                                guint property_id,
                                                GValue * value,
                                                GParamSpec * pspec);
static void _vala_display_display_window_set_property (GObject * object,
                                                guint property_id,
                                                const GValue * value,
                                                GParamSpec * pspec);

static inline gpointer
display_display_window_get_instance_private (DisplayDisplayWindow* self)
{
	return G_STRUCT_MEMBER_P (self, DisplayDisplayWindow_private_offset);
}

DisplayDisplayWindow*
display_display_window_construct (GType object_type,
                                  DisplayVirtualMonitor* virtual_monitor)
{
	DisplayDisplayWindow * self = NULL;
	g_return_val_if_fail (virtual_monitor != NULL, NULL);
	self = (DisplayDisplayWindow*) g_object_new (object_type, "virtual-monitor", virtual_monitor, NULL);
	return self;
}

DisplayDisplayWindow*
display_display_window_new (DisplayVirtualMonitor* virtual_monitor)
{
	return display_display_window_construct (DISPLAY_TYPE_DISPLAY_WINDOW, virtual_monitor);
}

DisplayVirtualMonitor*
display_display_window_get_virtual_monitor (DisplayDisplayWindow* self)
{
	DisplayVirtualMonitor* result;
	DisplayVirtualMonitor* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_virtual_monitor;
	result = _tmp0_;
	return result;
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

static void
display_display_window_set_virtual_monitor (DisplayDisplayWindow* self,
                                            DisplayVirtualMonitor* value)
{
	DisplayVirtualMonitor* old_value;
	g_return_if_fail (self != NULL);
	old_value = display_display_window_get_virtual_monitor (self);
	if (old_value != value) {
		DisplayVirtualMonitor* _tmp0_;
		_tmp0_ = _g_object_ref0 (value);
		_g_object_unref0 (self->priv->_virtual_monitor);
		self->priv->_virtual_monitor = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, display_display_window_properties[DISPLAY_DISPLAY_WINDOW_VIRTUAL_MONITOR_PROPERTY]);
	}
}

static GObject *
display_display_window_constructor (GType type,
                                    guint n_construct_properties,
                                    GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	DisplayDisplayWindow * self;
	GtkLabel* label = NULL;
	DisplayVirtualMonitor* _tmp0_;
	const gchar* _tmp1_;
	GtkLabel* _tmp2_ = NULL;
	GtkLabel* _tmp3_;
	gint scale_factor = 0;
	GtkStyleContext* _tmp4_;
	DisplayVirtualMonitor* _tmp5_;
	gint _tmp6_;
	gint _tmp7_;
	DisplayVirtualMonitor* _tmp8_;
	gint _tmp9_;
	gint _tmp10_;
	parent_class = G_OBJECT_CLASS (display_display_window_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, DISPLAY_TYPE_DISPLAY_WINDOW, DisplayDisplayWindow);
	_tmp0_ = self->priv->_virtual_monitor;
	_tmp1_ = display_virtual_monitor_get_display_name (_tmp0_);
	_tmp2_ = (GtkLabel*) gtk_label_new (_tmp1_);
	g_object_set ((GtkWidget*) _tmp2_, "margin", 12, NULL);
	g_object_ref_sink (_tmp2_);
	label = _tmp2_;
	_tmp3_ = label;
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp3_);
	gtk_widget_input_shape_combine_region ((GtkWidget*) self, NULL);
	gtk_window_set_accept_focus ((GtkWindow*) self, FALSE);
	gtk_window_set_decorated ((GtkWindow*) self, FALSE);
	gtk_window_set_resizable ((GtkWindow*) self, FALSE);
	gtk_window_set_deletable ((GtkWindow*) self, FALSE);
	gtk_widget_set_can_focus ((GtkWidget*) self, FALSE);
	gtk_window_set_skip_taskbar_hint ((GtkWindow*) self, TRUE);
	gtk_window_set_skip_pager_hint ((GtkWindow*) self, TRUE);
	gtk_window_set_type_hint ((GtkWindow*) self, GDK_WINDOW_TYPE_HINT_TOOLTIP);
	gtk_window_set_keep_above ((GtkWindow*) self, TRUE);
	gtk_window_stick ((GtkWindow*) self);
	_tmp4_ = gtk_widget_get_style_context ((GtkWidget*) self);
	scale_factor = gtk_style_context_get_scale (_tmp4_);
	_tmp5_ = self->priv->_virtual_monitor;
	_tmp6_ = display_virtual_monitor_get_current_x (_tmp5_);
	_tmp7_ = _tmp6_;
	_tmp8_ = self->priv->_virtual_monitor;
	_tmp9_ = display_virtual_monitor_get_current_y (_tmp8_);
	_tmp10_ = _tmp9_;
	gtk_window_move ((GtkWindow*) self, ((gint) (_tmp7_ / scale_factor)) + DISPLAY_DISPLAY_WINDOW_SPACING, ((gint) (_tmp10_ / scale_factor)) + DISPLAY_DISPLAY_WINDOW_SPACING);
	_g_object_unref0 (label);
	return obj;
}

static void
display_display_window_class_init (DisplayDisplayWindowClass * klass,
                                   gpointer klass_data)
{
	display_display_window_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &DisplayDisplayWindow_private_offset);
	G_OBJECT_CLASS (klass)->get_property = _vala_display_display_window_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_display_display_window_set_property;
	G_OBJECT_CLASS (klass)->constructor = display_display_window_constructor;
	G_OBJECT_CLASS (klass)->finalize = display_display_window_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), DISPLAY_DISPLAY_WINDOW_VIRTUAL_MONITOR_PROPERTY, display_display_window_properties[DISPLAY_DISPLAY_WINDOW_VIRTUAL_MONITOR_PROPERTY] = g_param_spec_object ("virtual-monitor", "virtual-monitor", "virtual-monitor", DISPLAY_TYPE_VIRTUAL_MONITOR, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
}

static void
display_display_window_instance_init (DisplayDisplayWindow * self,
                                      gpointer klass)
{
	self->priv = display_display_window_get_instance_private (self);
}

static void
display_display_window_finalize (GObject * obj)
{
	DisplayDisplayWindow * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, DISPLAY_TYPE_DISPLAY_WINDOW, DisplayDisplayWindow);
	_g_object_unref0 (self->priv->_virtual_monitor);
	G_OBJECT_CLASS (display_display_window_parent_class)->finalize (obj);
}

static GType
display_display_window_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (DisplayDisplayWindowClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) display_display_window_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (DisplayDisplayWindow), 0, (GInstanceInitFunc) display_display_window_instance_init, NULL };
	GType display_display_window_type_id;
	display_display_window_type_id = g_type_register_static (hdy_window_get_type (), "DisplayDisplayWindow", &g_define_type_info, 0);
	DisplayDisplayWindow_private_offset = g_type_add_instance_private (display_display_window_type_id, sizeof (DisplayDisplayWindowPrivate));
	return display_display_window_type_id;
}

GType
display_display_window_get_type (void)
{
	static volatile gsize display_display_window_type_id__volatile = 0;
	if (g_once_init_enter (&display_display_window_type_id__volatile)) {
		GType display_display_window_type_id;
		display_display_window_type_id = display_display_window_get_type_once ();
		g_once_init_leave (&display_display_window_type_id__volatile, display_display_window_type_id);
	}
	return display_display_window_type_id__volatile;
}

static void
_vala_display_display_window_get_property (GObject * object,
                                           guint property_id,
                                           GValue * value,
                                           GParamSpec * pspec)
{
	DisplayDisplayWindow * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, DISPLAY_TYPE_DISPLAY_WINDOW, DisplayDisplayWindow);
	switch (property_id) {
		case DISPLAY_DISPLAY_WINDOW_VIRTUAL_MONITOR_PROPERTY:
		g_value_set_object (value, display_display_window_get_virtual_monitor (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_display_display_window_set_property (GObject * object,
                                           guint property_id,
                                           const GValue * value,
                                           GParamSpec * pspec)
{
	DisplayDisplayWindow * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, DISPLAY_TYPE_DISPLAY_WINDOW, DisplayDisplayWindow);
	switch (property_id) {
		case DISPLAY_DISPLAY_WINDOW_VIRTUAL_MONITOR_PROPERTY:
		display_display_window_set_virtual_monitor (self, g_value_get_object (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

